"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

/**
 * @file ColorBlock component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var ColorBlock =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(ColorBlock, _Component);

  function ColorBlock(props) {
    var _getPrototypeOf2;

    (0, _classCallCheck2["default"])(this, ColorBlock);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(ColorBlock)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
  }

  (0, _createClass2["default"])(ColorBlock, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          value = _this$props.value,
          opacity = _this$props.opacity,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["className", "style", "value", "opacity"]);
      return _react["default"].createElement("div", (0, _extends2["default"])({}, restProps, {
        className: (0, _classnames["default"])('color-block', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }), _react["default"].createElement("div", {
        className: "color-block-overlay",
        style: {
          background: "#".concat(value),
          opacity: opacity
        }
      }));
    }
  }]);
  return ColorBlock;
}(_react.Component);

ColorBlock.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * rgb hex value
   */
  value: _propTypes["default"].string,
  opacity: _propTypes["default"].number
};
ColorBlock.defaultProps = {
  value: 'ff0000',
  opacity: 1
};
var _default = ColorBlock;
exports["default"] = _default;