"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

/**
 * @file DownloadField component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var DownloadField =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(DownloadField, _Component);

  function DownloadField(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, DownloadField);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(DownloadField)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "download", function () {
      _this.setState({
        downloading: true
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleLoaded", function (e) {
      _this.setState({
        downloading: false
      }, function () {
        var onLoad = _this.props.onLoad,
            iframeEl = _this.iframe && _this.iframe.current;
        iframeEl && onLoad && onLoad(e, iframeEl.contentDocument ? iframeEl.contentDocument.body.innerText : undefined);
      });
    });
    _this.iframe = (0, _react.createRef)();
    _this.state = {
      downloading: false
    };
    return _this;
  }

  (0, _createClass2["default"])(DownloadField, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (nextState.downloading !== this.state.downloading) {
        return true;
      }

      return false;
    }
  }, {
    key: "render",
    value: function render() {
      var url = this.props.url,
          downloading = this.state.downloading;
      return downloading ? _react["default"].createElement("iframe", {
        ref: this.iframe,
        className: "download-field",
        onLoad: this.handleLoaded,
        onError: this.handleLoaded,
        src: downloading ? url : null
      }) : null;
    }
  }]);
  return DownloadField;
}(_react.Component);

DownloadField.propTypes = {
  /**
   * Download url.
   */
  url: _propTypes["default"].string,

  /**
   * Loaded callback.
   */
  onLoad: _propTypes["default"].func
};
DownloadField.defaultProps = {
  url: null
};
var _default = DownloadField;
exports["default"] = _default;