"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Tip = _interopRequireDefault(require("../Tip"));

var _MsgType = _interopRequireDefault(require("../_statics/MsgType"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file FieldMsg component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var FieldMsg =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(FieldMsg, _Component);

  function FieldMsg(props) {
    var _getPrototypeOf2;

    (0, _classCallCheck2["default"])(this, FieldMsg);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(FieldMsg)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
  }

  (0, _createClass2["default"])(FieldMsg, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          style = _this$props.style,
          type = _this$props.type,
          visible = _this$props.visible,
          triggerEl = _this$props.triggerEl,
          position = _this$props.position,
          msg = _this$props.msg,
          parentEl = _this$props.parentEl;
      return _react["default"].createElement(_Tip["default"], {
        className: (0, _classnames["default"])('field-msg', (0, _defineProperty2["default"])({}, className, className)),
        contentClassName: "field-msg-content",
        style: style,
        theme: type,
        visible: visible,
        triggerEl: triggerEl,
        parentEl: parentEl,
        position: position
      }, msg, children);
    }
  }]);
  return FieldMsg;
}(_react.Component);

(0, _defineProperty2["default"])(FieldMsg, "Type", _MsgType["default"]);
(0, _defineProperty2["default"])(FieldMsg, "Position", _Position["default"]);
FieldMsg.propTypes = {
  children: _propTypes["default"].any,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_MsgType["default"])),
  visible: _propTypes["default"].bool,
  triggerEl: _propTypes["default"].object,
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  msg: _propTypes["default"].any,
  parentEl: _propTypes["default"].object
};
FieldMsg.defaultProps = {
  type: _MsgType["default"].DEFAULT,
  visible: false,
  position: _Position["default"].BOTTOM_LEFT
};
var _default = FieldMsg;
exports["default"] = _default;