"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Event = _interopRequireDefault(require("../_vendors/Event"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Rate =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Rate, _Component);

  function Rate(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Rate);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Rate)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTriggerEvent", function (el, triggerEl) {
      // console.log(el,triggerEl)
      while (el) {
        if (el == triggerEl) {
          return true;
        }

        el = el.parentNode;
      }

      return false;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseMove", function (e) {
      var disabled = _this.props.disabled;

      if (disabled) {
        return;
      }

      var mouseEnterFalg = _this.handleTriggerEvent(e.target, _this.wrapperEl);

      var value = _this.props.value; // console.log(mouseEnterFalg)

      if (mouseEnterFalg) {
        if (e.target.nodeName === 'I') {
          value = e.target.getAttribute('data-key');
        } else if (e.target.nodeName === 'DIV' && (e.target.className.indexOf('half-star') !== -1 || e.target.className.indexOf('star') !== -1)) {
          value = e.target.getAttribute('data-key');
        }
      } else {
        value = _this.props.value;
      } // if(value!==this.props.value){


      var items = _this.createItems(value);

      _this.setState({
        items: items
      }); // }

    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSelect", function (value, e) {
      e.preventDefault();
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          allowClear = _this$props.allowClear;

      if (disabled) {
        return;
      }

      if (value === _this.state.value && allowClear) {
        value = 0;
      }

      _this.setState({
        value: value
      }, function () {
        _this.props.onChange && _this.props.onChange(value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "createItems", function (value) {
      var _this$props2 = _this.props,
          allowHalf = _this$props2.allowHalf,
          count = _this$props2.count;
      var items = [];

      if (allowHalf) {
        for (var i = 0; i < count; i++) {
          if (i <= value - 1) {
            items.push('full');
          } else if (i < value && i > value - 1) {
            items.push('full-zero');
          } else if (i > value) {
            items.push('zero');
          } else {
            items.push('zero');
          }
        }
      } else {
        for (var _i = 0; _i < count; _i++) {
          if (_i < value) {
            items.push('full');
          } else if (_i > value) {
            items.push('zero');
          } else {
            items.push('zero');
          }
        }
      }

      return items;
    });
    _this.wrapper = (0, _react.createRef)();
    _this.wrapperEl = null;
    _this.state = {
      value: 0,
      items: []
    };
    return _this;
  }

  (0, _createClass2["default"])(Rate, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.wrapperEl = this.wrapper && this.wrapper.current;
      var value = this.props.value;
      var items = this.createItems(value);
      this.setState({
        value: value,
        items: items
      });

      _Event["default"].addEvent(document, 'mousemove', this.handleMouseMove);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.props.value) {
        var value = nextProps.value;
        var items = this.createItems(value);
        this.setState({
          value: value,
          items: items
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(document, 'mousemove', this.handleMouseMove);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          className = _this$props3.className,
          style = _this$props3.style,
          allowHalf = _this$props3.allowHalf,
          disabled = _this$props3.disabled,
          count = _this$props3.count,
          items = this.state.items;
      return _react["default"].createElement("div", {
        ref: this.wrapper,
        className: (0, _classnames["default"])('rate', (0, _defineProperty2["default"])({}, className, className)),
        style: _objectSpread({
          width: count * 30
        }, style)
      }, items && items.map(function (item, index) {
        return allowHalf ? _react["default"].createElement("div", {
          key: index,
          className: "half-star ".concat(disabled ? 'disabled' : ''),
          "data-key": index + 1
        }, _react["default"].createElement("div", {
          className: "half-star-left",
          "data-key": index + 0.5,
          onClick: function onClick(e) {
            _this2.handleSelect(index + 0.5, e);
          }
        }, _react["default"].createElement("i", {
          className: "fas fa-star-half ".concat(item == 'full' || item == 'full-zero' ? 'full' : 'zero', " ").concat(disabled ? 'disabled' : ''),
          "data-key": index + 0.5
        })), _react["default"].createElement("div", {
          className: "half-star-right",
          "data-key": index + 1,
          onClick: function onClick(e) {
            _this2.handleSelect(index + 1, e);
          }
        }, _react["default"].createElement("i", {
          className: "fas fa-star-half ".concat(item == 'zero' || item == 'full-zero' ? 'zero' : 'full', " ").concat(disabled ? 'disabled' : ''),
          "data-key": index + 1
        }))) : _react["default"].createElement("div", {
          key: index,
          className: "star ".concat(disabled ? 'disabled' : ''),
          "data-key": index + 1
        }, _react["default"].createElement("i", {
          className: "fas fa-star ".concat(item == 'zero' ? 'zero' : 'full', " ").concat(disabled ? 'disabled' : ''),
          "data-key": index + 1,
          onClick: function onClick(e) {
            _this2.handleSelect(index + 1, e);
          }
        }));
      }));
    }
  }]);
  return Rate;
}(_react.Component);

Rate.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The value of Rate component.
   */
  value: _propTypes["default"].number,

  /**
   * If true,the Rate will have half star.
   */
  allowHalf: _propTypes["default"].bool,

  /**
   * If true,the Rate component will be clear the value when double click.
   */
  allowClear: _propTypes["default"].bool,

  /**
   * If true,the Rate component will be disabled.
   */
  disabled: _propTypes["default"].bool,
  count: _propTypes["default"].number,

  /**
   * Callback function fired when the rate change.
   */
  onChange: _propTypes["default"].func
};
Rate.defaultProps = {
  allowClear: true,
  count: 5,
  defaultValue: 0,
  disabled: false
};
var _default = Rate;
exports["default"] = _default;