"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));

var _classnames = _interopRequireDefault(require("classnames"));

var _PositionPop = _interopRequireDefault(require("../_PositionPop"));

var _Toast = _interopRequireDefault(require("../_Toast"));

var _MsgType = _interopRequireDefault(require("../_statics/MsgType"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Toaster =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Toaster, _Component);

  function Toaster(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Toaster);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Toaster)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isPositiveSequence", function () {
      var position = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.position;
      return position !== _Position["default"].BOTTOM_LEFT && position !== _Position["default"].BOTTOM && position !== _Position["default"].BOTTOM_RIGHT;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "addToast", function (toast) {
      var toasts = _this.state.toasts;

      if (_this.isPositiveSequence()) {
        toasts.push(_objectSpread({}, toast, {
          toastsId: _this.nextKey++
        }));
      } else {
        toasts.unshift(_objectSpread({}, toast, {
          toastsId: _this.nextKey++
        }));
      }

      _this.setState({
        toasts: toasts,
        visible: true
      }, function () {
        _this.popInstance && _this.popInstance.resetPosition();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeToast", function (toastsId) {
      var toasts = _this.state.toasts;

      if (!toasts || toasts.length < 1) {
        return;
      }

      toasts.splice(toasts.findIndex(function (item) {
        return item.toastsId === toastsId;
      }), 1);

      _this.setState({
        toasts: toasts
      }, function () {
        if (toasts.length < 1) {
          _this.setState({
            visible: false
          }, function () {
            _this.popInstance && _this.popInstance.resetPosition();
          });
        }
      });
    });
    _this.nextKey = 0;
    _this.pop = (0, _react.createRef)();
    _this.popInstance = null;
    _this.state = {
      visible: false,
      toasts: []
    };
    return _this;
  }

  (0, _createClass2["default"])(Toaster, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.popInstance = this.pop && this.pop.current;
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (nextProps.toasts && nextProps.toasts.length > 0) {
        var toasts = (0, _cloneDeep["default"])(nextProps.toasts);

        for (var i = 0, len = toasts.length; i < len; i++) {
          if ((0, _typeof2["default"])(toasts[i]) !== 'object') {
            toasts[i] = {
              message: toasts[i]
            };
          }

          toasts[i].toastsId = this.nextKey++;
        }

        if (this.isPositiveSequence()) {
          toasts = [].concat((0, _toConsumableArray2["default"])(this.state.toasts), (0, _toConsumableArray2["default"])(toasts));
        } else {
          toasts = [].concat((0, _toConsumableArray2["default"])(toasts.reverse()), (0, _toConsumableArray2["default"])(this.state.toasts));
        }

        this.setState({
          toasts: toasts,
          visible: true
        }, function () {
          _this2.popInstance && _this2.popInstance.resetPosition();
          var onToastPop = _this2.props.onToastPop;
          onToastPop && onToastPop();
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
          _this3 = this;

      var _this$props = this.props,
          className = _this$props.className,
          position = _this$props.position,
          duration = _this$props.duration,
          onToastPop = _this$props.onToastPop,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["className", "position", "duration", "onToastPop"]),
          _this$state = this.state,
          toasts = _this$state.toasts,
          visible = _this$state.visible;
      return _react["default"].createElement(_PositionPop["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.pop,
        className: (0, _classnames["default"])('toaster', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "toaster-".concat(position), position), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        visible: visible,
        position: position
      }), toasts && toasts.map(function (options) {
        return _react["default"].createElement(_Toast["default"], (0, _extends2["default"])({}, options, {
          key: options.toastsId,
          duration: 'duration' in options ? options.duration : duration,
          onRequestClose: _this3.removeToast
        }));
      }));
    }
  }]);
  return Toaster;
}(_react.Component);

(0, _defineProperty2["default"])(Toaster, "Type", _MsgType["default"]);
(0, _defineProperty2["default"])(Toaster, "Position", _Position["default"]);
Toaster.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  parentEl: _propTypes["default"].object,

  /**
   * Children passed into the toaster.
   */
  toasts: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of toast.
     */
    className: _propTypes["default"].string,

    /**
     * Override the styles of the toast.
     */
    style: _propTypes["default"].object,

    /**
     * The type of toast.
     */
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_MsgType["default"])),

    /**
     * The message of toast.
     */
    message: _propTypes["default"].string,

    /**
     * The icon class name of toast.
     */
    iconCls: _propTypes["default"].string,

    /**
     * The duration of toast.
     */
    duration: _propTypes["default"].number
  }), _propTypes["default"].string, _propTypes["default"].number])),
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),

  /**
   * The duration of toast.
   */
  duration: _propTypes["default"].number,

  /**
   * Callback function fired when the toaster pop.
   */
  onToastPop: _propTypes["default"].func
};
Toaster.defaultProps = {
  parentEl: document.body,
  position: _Position["default"].TOP,
  duration: 2500
};
var _default = Toaster;
exports["default"] = _default;