"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Paper = _interopRequireDefault(require("../Paper"));

/**
 * @file Widget component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Widget =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Widget, _Component);

  function Widget(props) {
    var _getPrototypeOf2;

    (0, _classCallCheck2["default"])(this, Widget);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Widget)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
  }

  (0, _createClass2["default"])(Widget, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          style = _this$props.style,
          depth = _this$props.depth;
      return _react["default"].createElement(_Paper["default"], {
        className: (0, _classnames["default"])('widget', (0, _defineProperty2["default"])({}, className, className)),
        style: style,
        depth: depth
      }, children);
    }
  }]);
  return Widget;
}(_react.Component);

Widget.propTypes = {
  children: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * This number represents the zDepth of the root element shadow.
   */
  depth: _propTypes["default"].number
};
Widget.defaultProps = {
  depth: 1
};
var _default = Widget;
exports["default"] = _default;