"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

/**
 * @file WidgetHeader component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var WidgetHeader =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(WidgetHeader, _Component);

  function WidgetHeader(props) {
    var _getPrototypeOf2;

    (0, _classCallCheck2["default"])(this, WidgetHeader);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(WidgetHeader)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
  }

  (0, _createClass2["default"])(WidgetHeader, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          style = _this$props.style,
          title = _this$props.title;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('widget-header', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, title, _react["default"].createElement("div", {
        className: "right"
      }, children));
    }
  }]);
  return WidgetHeader;
}(_react.Component);

WidgetHeader.propTypes = {
  children: _propTypes["default"].any,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  title: _propTypes["default"].any
};
var _default = WidgetHeader;
exports["default"] = _default;