"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Percent =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Percent, _Component);

  function Percent(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Percent);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Percent)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "numberChange", function () {
      if (_this.state.percent < 100) {
        if (_this.state.percent < _this.props.endNum) {
          _this.setState({
            percent: _this.state.percent + 1
          });

          var time = 300 / (_this.props.endNum - _this.state.percent);
          _this.timer = setTimeout(function () {
            return _this.numberChange();
          }, time);
          return;
        }

        _this.timer = setTimeout(function () {
          return _this.numberChange();
        }, 30);
      }
    });
    _this.state = {
      percent: 0
    };
    return _this;
  }

  (0, _createClass2["default"])(Percent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.timer = setTimeout(function () {
        return _this2.numberChange();
      }, 30);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.timer);
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          move = _this$props.move,
          endNum = _this$props.endNum,
          status = _this$props.status,
          showIcon = _this$props.showIcon,
          successIcon = _this$props.successIcon,
          failureIcon = _this$props.failureIcon,
          percent = this.state.percent;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('circular-progress-percent', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, className, className), (0, _defineProperty2["default"])(_classNames, status, status), _classNames)),
        style: move === true ? _objectSpread({
          width: endNum + '%',
          textAlign: 'right'
        }, style) : style
      }, _react["default"].Children.map(this.props.children, function (child) {
        return _react["default"].createElement("span", null, child);
      }), status === 'loading' ? _react["default"].createElement("span", null, percent, "%") : null, showIcon && status === 'success' ? _react["default"].createElement("i", {
        className: successIcon || 'fa fa-check-circle'
      }) : null, showIcon && status === 'failure' ? _react["default"].createElement("i", {
        className: failureIcon || 'fa fa-times-circle'
      }) : null);
    }
  }]);
  return Percent;
}(_react.Component);

(0, _defineProperty2["default"])(Percent, "Status", {
  LOADING: 'loading',
  SUCCESS: 'success',
  FAILURE: 'failure'
});
Percent.propTypes = {
  children: _propTypes["default"].any,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,

  /**
   * The status of loading.
   */
  status: _propTypes["default"].oneOf(Object.keys(Percent.Status).map(function (key) {
    return Percent.Status[key];
  })),
  endNum: _propTypes["default"].number,
  move: _propTypes["default"].bool,
  showIcon: _propTypes["default"].string,
  successIcon: _propTypes["default"].string,
  failureIcon: _propTypes["default"].string
};
Percent.defaultProps = {
  endNum: 100,
  move: false
};
var _default = Percent;
exports["default"] = _default;