"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _CSSTransition = _interopRequireDefault(require("react-transition-group/CSSTransition"));

var _classnames = _interopRequireDefault(require("classnames"));

/**
 * @file Ripple component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Ripple =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Ripple, _Component);

  function Ripple(props) {
    var _getPrototypeOf2;

    (0, _classCallCheck2["default"])(this, Ripple);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Ripple)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
  }

  (0, _createClass2["default"])(Ripple, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          duration = _this$props.duration,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props, ["className", "style", "duration"]);
      return _react["default"].createElement(_CSSTransition["default"], (0, _extends2["default"])({}, restProps, {
        classNames: "ripple",
        timeout: {
          enter: duration,
          exit: duration * 2
        }
      }), _react["default"].createElement("div", {
        className: (0, _classnames["default"])('ripple', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }));
    }
  }]);
  return Ripple;
}(_react.Component);

Ripple.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  duration: _propTypes["default"].number
};
Ripple.defaultProps = {
  duration: 500
};
var _default = Ripple;
exports["default"] = _default;