"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

/**
 * @file ThSortingIcon component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var ThSortingIcon =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(ThSortingIcon, _Component);

  function ThSortingIcon(props) {
    var _getPrototypeOf2;

    (0, _classCallCheck2["default"])(this, ThSortingIcon);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(ThSortingIcon)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
  }

  (0, _createClass2["default"])(ThSortingIcon, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          sorting = _this$props.sorting,
          sortingProp = _this$props.sortingProp,
          sortingAscIconCls = _this$props.sortingAscIconCls,
          sortingDescIconCls = _this$props.sortingDescIconCls;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('th-sorting-icon-wrapper', sorting && sorting.type && sorting.prop === sortingProp ? sorting.type > 0 ? ' asc' : ' desc' : '')
      }, _react["default"].createElement("i", {
        className: "th-sorting-icon ".concat(sortingAscIconCls, " up"),
        "aria-hidden": "true"
      }), _react["default"].createElement("i", {
        className: "th-sorting-icon ".concat(sortingDescIconCls, " down"),
        "aria-hidden": "true"
      }));
    }
  }]);
  return ThSortingIcon;
}(_react.Component);

ThSortingIcon.propTypes = {
  sorting: _propTypes["default"].object,
  sortingProp: _propTypes["default"].string,
  sortingAscIconCls: _propTypes["default"].string,
  sortingDescIconCls: _propTypes["default"].string
};
ThSortingIcon.defaultProps = {
  sortingAscIconCls: 'fas fa-sort-up',
  sortingDescIconCls: 'fas fa-sort-down'
};
var _default = ThSortingIcon;
exports["default"] = _default;