"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _moment = _interopRequireDefault(require("moment"));

var _TouchRipple = _interopRequireDefault(require("../TouchRipple"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file DayPicker component
 * @author sunday(sunday.wei@derbysoft.com)
 */
var DayPicker =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(DayPicker, _Component);

  function DayPicker(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, DayPicker);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(DayPicker)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "previousLevel", function () {
      _this.props.previousClick && _this.props.previousClick('month');
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "hoverDateHandle", function (s_day) {
      var _this$state = _this.state,
          selectYear = _this$state.selectYear,
          selectMonth = _this$state.selectMonth;
      s_day = s_day.toString();
      var selected_month = Number(selectMonth) - 1;
      var timer = (0, _moment["default"])([selectYear, selected_month, s_day]).format(_this.props.dateFormat);
      _this.props.hoverHandle && _this.props.hoverHandle({
        time: timer,
        year: selectYear,
        month: selectMonth,
        day: s_day
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "selectDate", function (s_day) {
      var _this$state2 = _this.state,
          selectYear = _this$state2.selectYear,
          selectMonth = _this$state2.selectMonth,
          hour = _this$state2.hour,
          minute = _this$state2.minute,
          second = _this$state2.second;
      s_day = s_day.toString();
      var selected_month = Number(selectMonth) - 1;
      var timer = hour && minute && second ? (0, _moment["default"])([selectYear, selected_month, s_day, hour, minute, second]).format(_this.props.dateFormat) : (0, _moment["default"])([selectYear, selected_month, s_day]).format(_this.props.dateFormat);

      _this.setState({
        currentYear: selectYear,
        currentMonth: selectMonth,
        currentDay: s_day,
        selectDay: s_day
      }, function () {
        _this.props.onChange && _this.props.onChange({
          time: timer,
          year: selectYear,
          month: selectMonth,
          day: s_day
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "previousYear", function () {
      var _this$state3 = _this.state,
          currentYear = _this$state3.currentYear,
          currentMonth = _this$state3.currentMonth,
          currentDay = _this$state3.currentDay,
          selectYear = _this$state3.selectYear,
          selectMonth = _this$state3.selectMonth,
          selectDay = _this$state3.selectDay,
          date_num_array = _this$state3.date_num_array,
          first_day = _this$state3.first_day;
      selectYear = +selectYear - 1;
      date_num_array = _Util["default"].MonthDays(selectYear);
      first_day = _this.weekday(selectYear, selectMonth);
      selectDay = Number(currentYear) === Number(selectYear) && Number(currentMonth) === Number(selectMonth) ? currentDay : undefined;

      _this.setState({
        selectYear: selectYear,
        selectMonth: selectMonth,
        selectDay: selectDay,
        date_num_array: date_num_array,
        first_day: first_day
      }, function () {
        _this.props.monthAndYearChange && _this.props.monthAndYearChange({
          year: selectYear,
          month: selectMonth
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "previousMonth", function () {
      // debugger
      var _this$state4 = _this.state,
          currentYear = _this$state4.currentYear,
          currentMonth = _this$state4.currentMonth,
          currentDay = _this$state4.currentDay,
          selectYear = _this$state4.selectYear,
          selectMonth = _this$state4.selectMonth,
          selectDay = _this$state4.selectDay,
          date_num_array = _this$state4.date_num_array,
          first_day = _this$state4.first_day;

      if (selectMonth == 1) {
        selectYear = +selectYear - 1;
        selectMonth = 12;
        date_num_array = _Util["default"].MonthDays(selectYear);
      } else {
        selectMonth = +selectMonth - 1;
      }

      first_day = _this.weekday(selectYear, selectMonth);
      selectDay = Number(currentYear) === Number(selectYear) && Number(currentMonth) === Number(selectMonth) ? currentDay : undefined;

      _this.setState({
        selectYear: selectYear,
        selectMonth: selectMonth,
        selectDay: selectDay,
        date_num_array: date_num_array,
        first_day: first_day
      }, function () {
        _this.props.monthAndYearChange && _this.props.monthAndYearChange({
          year: selectYear,
          month: selectMonth
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "nextMonth", function () {
      // debugger
      var _this$state5 = _this.state,
          currentYear = _this$state5.currentYear,
          currentMonth = _this$state5.currentMonth,
          currentDay = _this$state5.currentDay,
          selectYear = _this$state5.selectYear,
          selectMonth = _this$state5.selectMonth,
          selectDay = _this$state5.selectDay,
          date_num_array = _this$state5.date_num_array,
          first_day = _this$state5.first_day;

      if (selectMonth == 12) {
        selectYear = +selectYear + 1;
        selectMonth = 1;
        date_num_array = _Util["default"].MonthDays(selectYear);
      } else {
        selectMonth = +selectMonth + 1;
      }

      first_day = _this.weekday(selectYear, selectMonth);
      selectDay = Number(currentYear) === Number(selectYear) && Number(currentMonth) === Number(selectMonth) ? currentDay : undefined;

      _this.setState({
        selectYear: selectYear,
        selectMonth: selectMonth,
        selectDay: selectDay,
        date_num_array: date_num_array,
        first_day: first_day
      }, function () {
        _this.props.monthAndYearChange && _this.props.monthAndYearChange({
          year: selectYear,
          month: selectMonth
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "nextYear", function () {
      var _this$state6 = _this.state,
          currentYear = _this$state6.currentYear,
          currentMonth = _this$state6.currentMonth,
          currentDay = _this$state6.currentDay,
          selectYear = _this$state6.selectYear,
          selectMonth = _this$state6.selectMonth,
          selectDay = _this$state6.selectDay,
          date_num_array = _this$state6.date_num_array,
          first_day = _this$state6.first_day;
      selectYear = +selectYear + 1;
      date_num_array = _Util["default"].MonthDays(selectYear);
      first_day = _this.weekday(selectYear, selectMonth);
      selectDay = Number(currentYear) === Number(selectYear) && Number(currentMonth) === Number(selectMonth) ? currentDay : undefined;

      _this.setState({
        selectYear: selectYear,
        selectMonth: selectMonth,
        selectDay: selectDay,
        date_num_array: date_num_array,
        first_day: first_day
      }, function () {
        _this.props.monthAndYearChange && _this.props.monthAndYearChange({
          year: selectYear,
          month: selectMonth
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "MonthEn", function (num) {
      num = num - 1;
      var MonthEn = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
      return MonthEn[num];
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "weekday", function (selectYear, selectMonth) {
      var num = new Date(selectYear + '/' + selectMonth + '/01').getDay();
      return num == 0 ? 7 : num;
    });
    _this.defaultTable = {
      row_number: 6,
      col_number: 7
    };
    var value = _this.props.value;
    _this.state = {
      selectYear: _this.props.year,
      selectMonth: _this.props.month,
      selectDay: _this.props.day,
      hour: _this.props.hour,
      minute: _this.props.minute,
      second: _this.props.second,
      currentYear: (0, _moment["default"])(value).format('YYYY'),
      currentMonth: (0, _moment["default"])(value).format('MM'),
      currentDay: (0, _moment["default"])(value).format('DD'),
      date_num_array: _Util["default"].MonthDays(_this.props.year),
      first_day: _this.weekday(_this.props.year, _this.props.month)
    };
    return _this;
  }

  (0, _createClass2["default"])(DayPicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          value = _this$props.value,
          year = _this$props.year,
          month = _this$props.month,
          day = _this$props.day,
          hour = _this$props.hour,
          minute = _this$props.minute,
          second = _this$props.second;

      if (year && month && day && value) {
        this.setState({
          selectYear: year,
          selectMonth: month,
          selectDay: day,
          hour: hour,
          minute: minute,
          second: second,
          currentYear: (0, _moment["default"])(value).format('YYYY'),
          currentMonth: (0, _moment["default"])(value).format('MM'),
          currentDay: (0, _moment["default"])(value).format('DD'),
          date_num_array: _Util["default"].MonthDays(year),
          first_day: this.weekday(year, month)
        });
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.props.value || nextProps.year !== this.props.year || nextProps.month !== this.props.month || nextProps.day !== this.props.day || nextProps.hour !== this.props.hour || nextProps.minute !== this.props.minute || nextProps.second !== this.props.second) {
        var value = nextProps.value;
        this.setState({
          selectYear: nextProps.year,
          selectMonth: nextProps.month,
          selectDay: nextProps.day,
          hour: nextProps.hour,
          minute: nextProps.minute,
          second: nextProps.second,
          currentYear: (0, _moment["default"])(value).format('YYYY'),
          currentMonth: (0, _moment["default"])(value).format('MM'),
          currentDay: (0, _moment["default"])(value).format('DD'),
          date_num_array: _Util["default"].MonthDays(nextProps.year),
          first_day: this.weekday(nextProps.year, nextProps.month)
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          isFooter = _this$props2.isFooter,
          isRange = _this$props2.isRange,
          startTime = _this$props2.startTime,
          endTime = _this$props2.endTime,
          hoverTime = _this$props2.hoverTime,
          maxValue = _this$props2.maxValue,
          minValue = _this$props2.minValue,
          previousYearIconCls = _this$props2.previousYearIconCls,
          previousMonthIconCls = _this$props2.previousMonthIconCls,
          nextYearIconCls = _this$props2.nextYearIconCls,
          nextMonthIconCls = _this$props2.nextMonthIconCls;
      var _this$state7 = this.state,
          date_num_array = _this$state7.date_num_array,
          selectYear = _this$state7.selectYear,
          selectMonth = _this$state7.selectMonth,
          selectDay = _this$state7.selectDay,
          first_day = _this$state7.first_day,
          currentYear = _this$state7.currentYear,
          currentMonth = _this$state7.currentMonth;
      var previousMonth = this.previousMonth,
          previousYear = this.previousYear,
          nextYear = this.nextYear,
          nextMonth = this.nextMonth,
          selectDate = this.selectDate,
          previousLevel = this.previousLevel;
      var month = Number(selectMonth);
      var MonthEn = this.MonthEn(month);
      month = month - 1;
      var month_days = date_num_array[month];
      var previous_month_days = month === 0 ? 31 : date_num_array[month - 1],
          n_day = this.defaultTable.row_number * this.defaultTable.col_number - first_day - month_days,
          previous_days = [],
          current_days = [],
          next_days = [],
          total_days = [],
          ul_list = [];

      for (var i = 0; i < first_day; i++) {
        previous_days.push(_react["default"].createElement("li", {
          className: "item-gray",
          key: 'previous' + i
        }, _react["default"].createElement("a", {
          href: "javascript:;"
        }, previous_month_days - (first_day - i) + 1)));
      }

      if (isRange) {
        var start, end, hover;
        start = (0, _moment["default"])(endTime).isBefore(startTime) ? endTime : startTime;
        end = (0, _moment["default"])(endTime).isBefore(startTime) ? startTime : endTime;
        start = (0, _moment["default"])(hoverTime).isBefore(startTime) ? hoverTime : startTime;
        hover = (0, _moment["default"])(hoverTime).isBefore(startTime) ? startTime : hoverTime;

        var _loop = function _loop(_i) {
          var item = (0, _moment["default"])([Number(selectYear), Number(selectMonth) - 1, _i + 1]).format('YYYY-MM-DD');
          var liClassName = "".concat(start == item ? 'start' : '', " ").concat(item == end || item == hover ? 'end' : '', " ").concat((0, _moment["default"])(start).isBefore(item) && (0, _moment["default"])(item).isBefore(end) || (0, _moment["default"])(start).isBefore(item) && (0, _moment["default"])(item).isBefore(hover) ? 'hover' : '', " ").concat(_i == 0 ? 'first-day' : '', " ").concat(_i == +month_days - 1 ? 'last-day' : '', "\n                    ").concat(minValue && (0, _moment["default"])(item).isBefore(minValue) || maxValue && (0, _moment["default"])(maxValue).isBefore(item) ? 'item-gray' : 'current-days');

          var current_link = _react["default"].createElement("li", {
            className: liClassName,
            key: 'current' + _i,
            onClick: function onClick() {
              liClassName.indexOf('item-gray') === -1 && selectDate(_i + 1);
            },
            onMouseOver: function onMouseOver() {
              liClassName.indexOf('item-gray') === -1 && _this2.hoverDateHandle(_i + 1);
            }
          }, _react["default"].createElement("a", {
            href: "javascript:;"
          }, _i + 1, liClassName.indexOf('item-gray') === -1 ? _react["default"].createElement(_TouchRipple["default"], null) : null));

          current_days.push(current_link);
        };

        for (var _i = 0; _i < Number(month_days); _i++) {
          _loop(_i);
        }
      } else {
        var _loop2 = function _loop2(_i2) {
          var item = (0, _moment["default"])([Number(selectYear), Number(selectMonth) - 1, _i2 + 1]).format('YYYY-MM-DD');
          var liClassName = "".concat(selectYear == currentYear && selectMonth == currentMonth && _i2 + 1 == selectDay ? 'active' : '', " \n                ").concat(minValue && (0, _moment["default"])(item).isBefore(minValue) || maxValue && (0, _moment["default"])(maxValue).isBefore(item) ? 'item-gray' : 'current-days');

          var current_link = _react["default"].createElement("li", {
            className: liClassName,
            key: 'current' + _i2,
            onClick: function onClick() {
              liClassName.indexOf('item-gray') === -1 && selectDate(_i2 + 1);
            }
          }, _react["default"].createElement("a", {
            href: "javascript:;"
          }, _i2 + 1, liClassName.indexOf('item-gray') === -1 ? _react["default"].createElement(_TouchRipple["default"], null) : null));

          current_days.push(current_link);
        };

        for (var _i2 = 0; _i2 < Number(month_days); _i2++) {
          _loop2(_i2);
        }
      }

      for (var _i3 = 0; _i3 < n_day; _i3++) {
        next_days.push(_react["default"].createElement("li", {
          className: "item-gray",
          key: 'previous' + _i3
        }, _react["default"].createElement("a", {
          href: "javascript:;"
        }, _i3 + 1)));
      }

      total_days = previous_days.concat(current_days, next_days);

      if (total_days.length > 0) {
        for (var _i4 = 0; _i4 < this.defaultTable.row_number; _i4++) {
          var li_list = [],
              start_index = _i4 * this.defaultTable.col_number,
              end_index = (_i4 + 1) * this.defaultTable.col_number;

          for (var j = start_index; j < end_index; j++) {
            li_list.push(total_days[j]);
          }

          ul_list.push(li_list);
        }
      }

      return _react["default"].createElement("div", {
        className: "calendar"
      }, _react["default"].createElement("div", {
        className: "calendar-header"
      }, minValue ? (0, _moment["default"])(minValue).format('YYYY') < +selectYear - 1 || (0, _moment["default"])(minValue).format('YYYY') == +selectYear - 1 && (0, _moment["default"])(minValue).format('MM') <= selectMonth ? _react["default"].createElement("i", {
        className: "previous-year ".concat(previousYearIconCls),
        onClick: previousYear
      }, _react["default"].createElement(_TouchRipple["default"], null)) : null : _react["default"].createElement("i", {
        className: "previous-year ".concat(previousYearIconCls),
        onClick: previousYear
      }, _react["default"].createElement(_TouchRipple["default"], null)), minValue ? (0, _moment["default"])(minValue).format('YYYY') == selectYear && (0, _moment["default"])(minValue).format('MM') < selectMonth || (0, _moment["default"])(minValue).format('YYYY') < selectYear ? _react["default"].createElement("i", {
        className: "previous-month ".concat(previousMonthIconCls),
        onClick: previousMonth
      }, _react["default"].createElement(_TouchRipple["default"], null)) : null : _react["default"].createElement("i", {
        className: "previous-month ".concat(previousMonthIconCls),
        onClick: previousMonth
      }, _react["default"].createElement(_TouchRipple["default"], null)), _react["default"].createElement("span", {
        onClick: previousLevel
      }, MonthEn, " ", selectYear), maxValue ? (0, _moment["default"])(maxValue).format('YYYY') == selectYear && selectMonth < (0, _moment["default"])(maxValue).format('MM') || maxValue && selectYear < (0, _moment["default"])(maxValue).format('YYYY') ? _react["default"].createElement("i", {
        className: "next-month ".concat(nextMonthIconCls),
        onClick: nextMonth
      }, _react["default"].createElement(_TouchRipple["default"], null)) : null : _react["default"].createElement("i", {
        className: "next-month ".concat(nextMonthIconCls),
        onClick: nextMonth
      }, _react["default"].createElement(_TouchRipple["default"], null)), maxValue ? selectYear < +(0, _moment["default"])(maxValue).format('YYYY') - 1 || selectYear == (0, _moment["default"])(maxValue).format('YYYY') - 1 && selectMonth <= (0, _moment["default"])(maxValue).format('MM') ? _react["default"].createElement("i", {
        className: "next-year ".concat(nextYearIconCls),
        onClick: nextYear
      }, _react["default"].createElement(_TouchRipple["default"], null)) : null : _react["default"].createElement("i", {
        className: "next-year ".concat(nextYearIconCls),
        onClick: nextYear
      }, _react["default"].createElement(_TouchRipple["default"], null))), _react["default"].createElement("div", {
        className: "calendar-body calendar-day-body ".concat(isFooter ? '' : ' maxHeight')
      }, _react["default"].createElement("ul", {
        className: "c-body-head"
      }, _react["default"].createElement("li", null, "Sun"), _react["default"].createElement("li", null, "Mon"), _react["default"].createElement("li", null, "Tue"), _react["default"].createElement("li", null, "Wed"), _react["default"].createElement("li", null, "Thu"), _react["default"].createElement("li", null, "Fri"), _react["default"].createElement("li", null, "Sat")), _react["default"].createElement("div", {
        className: "c-body-content"
      }, ul_list && ul_list.map(function (item, key) {
        return _react["default"].createElement("ul", {
          key: 'ul' + key,
          className: "content-row margin-5"
        }, item);
      }))));
    }
  }]);
  return DayPicker;
}(_react.Component);

DayPicker.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  value: _propTypes["default"].any,
  maxValue: _propTypes["default"].any,
  minValue: _propTypes["default"].any,
  year: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  month: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  day: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  dateFormat: _propTypes["default"].string,
  isRange: _propTypes["default"].bool,
  isFooter: _propTypes["default"].bool,
  onChange: _propTypes["default"].func,
  previousClick: _propTypes["default"].func
};
DayPicker.defaultProps = {
  isFooter: false
};
var _default = DayPicker;
exports["default"] = _default;