"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file MaterialFieldSeparator component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var MaterialFieldSeparator =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(MaterialFieldSeparator, _Component);

  function MaterialFieldSeparator(props) {
    var _getPrototypeOf2;

    (0, _classCallCheck2["default"])(this, MaterialFieldSeparator);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(MaterialFieldSeparator)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
  }

  (0, _createClass2["default"])(MaterialFieldSeparator, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          theme = _this$props.theme,
          isHover = _this$props.isHover,
          isFocus = _this$props.isFocus,
          disabled = _this$props.disabled;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])('material-field-separator', (0, _defineProperty2["default"])({
          hover: isHover,
          focused: isFocus
        }, "theme-".concat(theme), theme)),
        disabled: disabled
      }, _react["default"].createElement("div", {
        className: "material-field-separator-hover"
      }), _react["default"].createElement("div", {
        className: "material-field-separator-focus"
      }));
    }
  }]);
  return MaterialFieldSeparator;
}(_react.Component);

(0, _defineProperty2["default"])(MaterialFieldSeparator, "Theme", _Theme["default"]);
MaterialFieldSeparator.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  isHover: _propTypes["default"].bool,
  isFocus: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool
};
MaterialFieldSeparator.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  isHover: false,
  isFocus: false,
  disabled: false
};
var _default = MaterialFieldSeparator;
exports["default"] = _default;