"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _DropdownSelect = _interopRequireDefault(require("../DropdownSelect"));

/**
 * @file PaginationSize component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var PaginationSize =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(PaginationSize, _Component);

  function PaginationSize(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, PaginationSize);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(PaginationSize)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePageSizeChange", function (newPageSize) {
      var _this$props = _this.props,
          pageSize = _this$props.pageSize,
          onPageSizeChange = _this$props.onPageSizeChange;
      pageSize != newPageSize && onPageSizeChange && onPageSizeChange(newPageSize);
    });
    return _this;
  }

  (0, _createClass2["default"])(PaginationSize, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          pageSize = _this$props2.pageSize,
          pageSizes = _this$props2.pageSizes,
          valueField = _this$props2.valueField,
          displayField = _this$props2.displayField,
          rightIconCls = _this$props2.rightIconCls,
          parentEl = _this$props2.parentEl,
          temp = pageSizes.find(function (item) {
        return item && item.value === pageSize;
      }),
          value = temp ? temp : pageSize;
      return _react["default"].createElement("div", {
        className: "pagination-size ".concat(className),
        style: style
      }, _react["default"].createElement("label", null, "Show Rows:"), _react["default"].createElement(_DropdownSelect["default"], {
        className: "pagination-size-select",
        value: value,
        data: pageSizes,
        autoClose: true,
        valueField: valueField,
        displayField: displayField,
        parentEl: parentEl,
        rightIconCls: rightIconCls,
        onChange: this.handlePageSizeChange
      }));
    }
  }]);
  return PaginationSize;
}(_react.Component);

PaginationSize.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  pageSize: _propTypes["default"].number,
  pageSizes: _propTypes["default"].array,
  valueField: _propTypes["default"].string,
  displayField: _propTypes["default"].string,
  rightIconCls: _propTypes["default"].string,
  parentEl: _propTypes["default"].object,
  onPageSizeChange: _propTypes["default"].func
};
PaginationSize.defaultProps = {
  pageSize: 10,
  pageSizes: [5, 10, 15, 20],
  valueField: 'value',
  displayField: 'text',
  rightIconCls: 'fas fa-angle-down'
};
var _default = PaginationSize;
exports["default"] = _default;