"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _Transition = _interopRequireDefault(require("react-transition-group/Transition"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Portal = _interopRequireDefault(require("../Portal"));

var _Theme = _interopRequireDefault(require("../Theme"));

var _Position = _interopRequireDefault(require("../_statics/Position"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

var _Event = _interopRequireDefault(require("../_vendors/Event"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Pop =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Pop, _Component);

  function Pop(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Pop);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Pop)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs))); // this.scrollEl = null;

    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getEl", function () {
      return _this.state.transitionEl;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleEnter", function (el) {
      var _this$props = _this.props,
          triggerEl = _this$props.triggerEl,
          resetPosition = _this$props.resetPosition;
      resetPosition && resetPosition(el);

      _this.setState({
        enter: true,
        transitionEl: el
      }, function () {
        var onRender = _this.props.onRender;
        onRender && onRender(el, triggerEl);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleEntered", function (el) {
      var _this$props2 = _this.props,
          triggerEl = _this$props2.triggerEl,
          onRendered = _this$props2.onRendered;
      onRendered && onRendered(el, triggerEl);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleExit", function (el) {
      _this.setState({
        enter: false
      }, function () {
        var _this$props3 = _this.props,
            triggerEl = _this$props3.triggerEl,
            onDestroy = _this$props3.onDestroy;
        onDestroy && onDestroy(el, triggerEl);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleExited", function (el) {
      _this.setState({
        exited: true,
        transitionEl: null
      }, function () {
        var _this$props4 = _this.props,
            triggerEl = _this$props4.triggerEl,
            onDestroyed = _this$props4.onDestroyed;
        onDestroyed && onDestroyed(el, triggerEl);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "debounceResetPosition", (0, _debounce["default"])(function () {
      var resetPosition = _this.props.resetPosition;
      resetPosition && resetPosition(_this.state.transitionEl);
    }, _this.props.resetPositionWait));
    _this.state = {
      enter: false,
      exited: true,
      transitionEl: null
    };
    return _this;
  }
  /**
   * public
   */


  (0, _createClass2["default"])(Pop, [{
    key: "componentDidMount",
    // addWatchScroll = () => {
    //
    //     const {triggerEl} = this.props;
    //
    //     if (!triggerEl) {
    //         return;
    //     }
    //
    //     const scrollEl = Dom.getClosestScrollable(triggerEl);
    //
    //     if (!scrollEl || scrollEl == document.body) {
    //         return;
    //     }
    //
    //     this.scrollEl = scrollEl;
    //
    //     Event.addEvent(scrollEl, 'scroll', this.debounceResetPosition);
    //
    // };
    value: function componentDidMount() {
      _Event["default"].addEvent(window, 'resize', this.debounceResetPosition);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.position !== this.props.position) {
        var resetPosition = this.props.resetPosition;
        resetPosition && resetPosition(this.state.transitionEl);
      } // if (!prevProps.visible && this.props.visible) {
      //     this.addWatchScroll();
      // } else if (prevProps.visible && !this.props.visible) {
      //     this.scrollEl && Event.removeEvent(this.scrollEl, 'scroll', this.debounceResetPosition);
      //     this.scrollEl = null;
      // }

    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(window, 'resize', this.debounceResetPosition);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
          children = _this$props5.children,
          container = _this$props5.container,
          modalClassName = _this$props5.modalClassName,
          className = _this$props5.className,
          parentEl = _this$props5.parentEl,
          isAnimated = _this$props5.isAnimated,
          visible = _this$props5.visible,
          showModal = _this$props5.showModal,
          onModalMouseDown = _this$props5.onModalMouseDown,
          onModalMouseMove = _this$props5.onModalMouseMove,
          onModalMouseUp = _this$props5.onModalMouseUp,
          onModalMouseEnter = _this$props5.onModalMouseEnter,
          onModalMouseLeave = _this$props5.onModalMouseLeave,
          onModalClick = _this$props5.onModalClick,
          contentClassName = _this$props5.contentClassName,
          position = _this$props5.position,
          triggerEl = _this$props5.triggerEl,
          resetPositionWait = _this$props5.resetPositionWait,
          resetPosition = _this$props5.resetPosition,
          onRender = _this$props5.onRender,
          onRendered = _this$props5.onRendered,
          onDestroy = _this$props5.onDestroy,
          onDestroyed = _this$props5.onDestroyed,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props5, ["children", "container", "modalClassName", "className", "parentEl", "isAnimated", "visible", "showModal", "onModalMouseDown", "onModalMouseMove", "onModalMouseUp", "onModalMouseEnter", "onModalMouseLeave", "onModalClick", "contentClassName", "position", "triggerEl", "resetPositionWait", "resetPosition", "onRender", "onRendered", "onDestroy", "onDestroyed"]),
          _this$state = this.state,
          enter = _this$state.enter,
          exited = _this$state.exited,
          transitionEl = _this$state.transitionEl;
      return _react["default"].createElement(_Portal["default"], {
        visible: !exited,
        parentEl: parentEl
      }, showModal ? _react["default"].createElement(_Transition["default"], {
        appear: true,
        "in": visible,
        timeout: 250
      }, _react["default"].createElement("div", {
        className: (0, _classnames["default"])('pop-modal', (0, _defineProperty2["default"])({
          hidden: !enter,
          'pop-modal-animated': isAnimated
        }, modalClassName, modalClassName)),
        onMouseDown: onModalMouseDown,
        onMouseMove: onModalMouseMove,
        onMouseUp: onModalMouseUp,
        onMouseEnter: onModalMouseEnter,
        onMouseLeave: onModalMouseLeave,
        onClick: onModalClick
      })) : null, _react["default"].createElement(_Transition["default"], {
        appear: true,
        "in": visible,
        timeout: 250,
        onEnter: this.handleEnter,
        onEntered: this.handleEntered,
        onExit: this.handleExit,
        onExited: this.handleExited
      }, (0, _react.cloneElement)(container, _objectSpread({}, restProps, {
        className: (0, _classnames["default"])((0, _defineProperty2["default"])({
          hidden: !enter
        }, className, className)),
        children: typeof children === 'function' ? children(transitionEl) : children
      }))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props) {
      var result = {
        prevProps: props
      };

      if (props.visible) {
        result.exited = !props.visible;
      }

      return result;
    }
  }]);
  return Pop;
}(_react.Component);

(0, _defineProperty2["default"])(Pop, "Position", _Position["default"]);
(0, _defineProperty2["default"])(Pop, "Theme", _Theme["default"]);
Pop.propTypes = {
  children: _propTypes["default"].any,
  container: _propTypes["default"].any,

  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * The CSS class name of the content element.
   */
  contentClassName: _propTypes["default"].string,
  modalClassName: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,

  /**
   * The trigger pop theme.Can be primary,highlight,success,warning,error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  parentEl: _propTypes["default"].object,

  /**
   * This is the DOM element that will be used to set the position of the trigger pop.
   */
  triggerEl: _propTypes["default"].object,

  /**
   * If true,the trigger pop is visible.
   */
  visible: _propTypes["default"].bool,
  showModal: _propTypes["default"].bool,

  /**
   * The trigger pop alignment.The value can be Popup.Position.LEFT or Popup.Position.RIGHT.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),

  /**
   * If true,popup will have animation effects.
   */
  isAnimated: _propTypes["default"].bool,

  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,
  resetPositionWait: _propTypes["default"].number,

  /**
   * The function of popup render.
   */
  onRender: _propTypes["default"].func,

  /**
   * The function of popup rendered.
   */
  onRendered: _propTypes["default"].func,

  /**
   * The function of popup destroy.
   */
  onDestroy: _propTypes["default"].func,

  /**
   * The function of popup destroyed.
   */
  onDestroyed: _propTypes["default"].func,
  resetPosition: _propTypes["default"].func,
  onModalMouseDown: _propTypes["default"].func,
  onModalMouseMove: _propTypes["default"].func,
  onModalMouseUp: _propTypes["default"].func,
  onModalMouseEnter: _propTypes["default"].func,
  onModalMouseLeave: _propTypes["default"].func,
  onModalClick: _propTypes["default"].func
};
Pop.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  parentEl: document.body,
  depth: 2,
  visible: false,
  showModal: false,
  position: _Position["default"].BOTTOM,
  isAnimated: true,
  resetPositionWait: 250
};
var _default = Pop;
exports["default"] = _default;