"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var ScrollableTable =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(ScrollableTable, _Component);

  function ScrollableTable(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, ScrollableTable);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(ScrollableTable)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getStyle", function () {
      var _this$props = _this.props,
          style = _this$props.style,
          scroll = _this$props.scroll,
          overflowHidden = _this$props.overflowHidden,
          horizontalOverflowScroll = _this$props.horizontalOverflowScroll;

      if (overflowHidden) {
        return style;
      }

      return _objectSpread({}, style, {
        overflowX: horizontalOverflowScroll ? 'scroll' : scroll.width ? 'auto' : null,
        overflowY: scroll.height || scroll.maxHeight ? 'scroll' : null
      });
    });
    return _this;
  }

  (0, _createClass2["default"])(ScrollableTable, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          children = _this$props2.children,
          style = _this$props2.style,
          scroll = _this$props2.scroll,
          overflowHidden = _this$props2.overflowHidden,
          horizontalOverflowScroll = _this$props2.horizontalOverflowScroll,
          restProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["children", "style", "scroll", "overflowHidden", "horizontalOverflowScroll"]);
      return scroll ? _react["default"].createElement("div", (0, _extends2["default"])({}, restProps, {
        style: this.getStyle()
      }), children) : children;
    }
  }]);
  return ScrollableTable;
}(_react.Component);

ScrollableTable.propTypes = {
  children: _propTypes["default"].any,
  style: _propTypes["default"].object,

  /**
   * scroll
   */
  scroll: _propTypes["default"].shape({
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    height: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    maxHeight: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
  }),
  overflowHidden: _propTypes["default"].bool,
  horizontalOverflowScroll: _propTypes["default"].bool
};
ScrollableTable.defaultProps = {
  overflowHidden: false,
  horizontalOverflowScroll: false
};
var _default = ScrollableTable;
exports["default"] = _default;