"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));

var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));

var _Util = _interopRequireDefault(require("../_vendors/Util"));

/**
 * @file Tf component
 * @author liangxiaojun(liangxiaojun@derbysoft.com)
 */
var Tf =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(Tf, _Component);

  function Tf(props) {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Tf);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Tf)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRender", function () {
      var _this$props = _this.props,
          colIndex = _this$props.colIndex,
          data = _this$props.data,
          renderer = _this$props.renderer;

      switch ((0, _typeof2["default"])(renderer)) {
        case 'function':
          return renderer(data, colIndex);

        default:
          return renderer;
      }
    });
    return _this;
  }
  /**
   * handle th content render
   * @returns {*}
   */


  (0, _createClass2["default"])(Tf, [{
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          align = _this$props2.align,
          noWrap = _this$props2.noWrap,
          span = _this$props2.span,
          onCellClick = _this$props2.onCellClick;
      return _react["default"].createElement("td", {
        className: (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "align-".concat(align), align && align !== _HorizontalAlign["default"].LEFT), (0, _defineProperty2["default"])(_classNames, 'no-wrap', noWrap), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        colSpan: span || null,
        onClick: onCellClick
      }, this.handleRender());
    }
  }]);
  return Tf;
}(_react.Component);

(0, _defineProperty2["default"])(Tf, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(Tf, "SortingType", _SortingType["default"]);
Tf.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  colIndex: _propTypes["default"].number,
  data: _propTypes["default"].array,
  renderer: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func]),
  align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
  span: _propTypes["default"].number,
  noWrap: _propTypes["default"].bool,
  onCellClick: _propTypes["default"].func
};
Tf.defaultProps = {
  colIndex: 0,
  align: _HorizontalAlign["default"].LEFT,
  noWrap: false
};
var _default = Tf;
exports["default"] = _default;