"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

/**
 * @file TimeLineItem component
 * @author wendy(wendy.wei@derbysoft.com)
 */
var TimeLineItem =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2["default"])(TimeLineItem, _Component);

  function TimeLineItem(props) {
    var _getPrototypeOf2;

    (0, _classCallCheck2["default"])(this, TimeLineItem);

    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }

    return (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(TimeLineItem)).call.apply(_getPrototypeOf2, [this, props].concat(restArgs)));
  }

  (0, _createClass2["default"])(TimeLineItem, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          date = _this$props.date,
          theme = _this$props.theme,
          type = _this$props.type,
          headerText = _this$props.headerText,
          contentText = _this$props.contentText,
          hasBorder = _this$props.hasBorder,
          style = _this$props.style;
      return _react["default"].createElement("li", {
        className: (0, _classnames["default"])('time-line-item', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, type && type == 'header' ? _react["default"].createElement("div", {
        className: "time-line-item-header"
      }, headerText) : type && type == 'title' ? _react["default"].createElement("div", {
        className: "time-line-item-title time-line-item-title-".concat(theme)
      }, _react["default"].createElement("span", {
        className: "tl-date"
      }, date), hasBorder ? _react["default"].createElement("div", {
        className: "tl-content panel panel-".concat(theme)
      }, _react["default"].createElement("span", {
        className: "triangle triangle-".concat(theme)
      }), _react["default"].createElement("span", {
        className: "tag tag-".concat(theme)
      }), _react["default"].createElement("div", null, contentText)) : _react["default"].createElement("div", {
        className: "tl-content"
      }, contentText)) : null);
    }
  }]);
  return TimeLineItem;
}(_react.Component);

(0, _defineProperty2["default"])(TimeLineItem, "Type", {
  HEADER: 'header',
  TITLE: 'title'
});
TimeLineItem.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,

  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object
};
var _default = TimeLineItem;
exports["default"] = _default;